KILLALL(1)

NAZWA
killall - zakończ procesy o danej nazwie

SKŁADNIA
killall [-d,--sid] [-c,--context] [-e,--exact] [-g,--process-group] [-i,--interactive] [-q,--quiet] [-s,--signal sygnał] [-v,--verbose] [-w,--wait] [-V,--version] [--] nazwa ...
killall -l
killall -V,--version

OPIS
killall wysyła sygnał do wszystkich procesów wymienionych w linii poleceń. Jeżeli nie podano nazwy sygnału, wysyłany jest sygnał SIGTERM.

Sygnały mogą być określane za pomocą nazwy (np. -HUP) lub numeru (np. -1).

Jeżeli nazwa polecenia zawiera ukośnik (/), sygnał wysyłany będzie do procesów wykonujących to polecenie, niezależnie od ich nazwy.

killall zwraca zerowy kod wyjścia, jeżeli dla każdego podanego polecenia przynajmniej jeden proces został zabity (zakończony). W przeciwnym razie killall zwraca niezerowy kod wyjścia.

Proces killall nigdy nie zabija samego siebie (chociaż może zabić inne procesy killall).

OPCJE

-e, --exact
    Wymusza dokładne dopasowanie bardzo długich nazw. Jeżeli nazwa polecenia jest dłuższa niż 15 znaków, jej pełna postać może być niedostępna. W tym przypadku killall zabije wszystkie procesy, których nazwa polecenia zgadza się z podaną w pierwszych 15 znakach. Po podaniu opcji -e takie procesy są pomijane. Program informuje o każdym takim przypadku, jeżeli dodatkowo podano opcję -v.

-I, --ignore-case
    Dopasowuje nazwy procesów, ignorując różnice w wielkości liter.

-g, --process-group
    Zabija grupę procesów, do której należy podany proces. Sygnał jest wysyłany tylko raz do danej grupy, nawet wtedy gdy w linii poleceń podano kilka procesów należących do tej samej grupy procesów.

-i, --interactive
    Pyta o zgodę przed zabiciem każdego procesu.

-l, --list
    Wypisuje wszystkie znane nazwy sygnałów.

-q, --quiet
    Nie wypisuje odnośnego komunikatu, gdy nie zabito żadnego procesu.

-v, --verbose
    Wypisuje komunikat o każdym udanym wysłaniu sygnału.

-V, --version
    Wypisuje informację o wersji programu.

-w, --wait
    Czeka, aż wszystkie zabite procesy zakończą działanie. killall sprawdza co sekundę, czy któryś z zabitych procesów jeszcze istnieje i kończy działanie dopiero, gdy wszystkie skończą pracę. Zauważ, że killall może czekać bez końca, gdy sygnał został zignorowany, nie zadziałał lub proces przeszedł do stanu zombie.

-d  (tylko Flask) Określa SID: zabija procesy tylko z podanym SID. Wyklucza użycie argumentu -c. Musi poprzedzać inne argumenty linii poleceń.

-c  (tylko Flask) Określa kontekst bezpieczeństwa: zabija tylko procesy mające podany kontekst bezpieczeństwa. Wyklucza użycie -d. Musi poprzedzać inne argumenty linii poleceń.

PLIKI
/proc	lokalizacja systemu plików proc

ZNANE PROBLEMY
Zabijanie procesów na podstawie nazwy pliku działa tylko wtedy, gdy plik wykonywalny jest podczas wykonywania w stanie otwartym.

Wydanie polecenia killall nazwa może nie działać zgodnie z oczekiwaniami na systemach nielinuksowych, zwłaszcza gdy zostanie wydane przez uprzywilejowanego użytkownika.

killall -w nie wykrywa sytuacji, w której proces znika i zostaje zastąpiony przez inny z tym samym numerem PID.

AUTORZY
Werner Almesberger <Werner.Almesberger@epfl.ch> napisał oryginalne psmisc. Od wersji 20 można obwiniać Craiga Smalla <csmall@small.dropbear.id.au>.

ZOBACZ TAKŻE
kill(1), fuser(1), pgrep(1), pidof(1), pkill(1), ps(1), kill(2)